(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright (c) 2013-2014 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: history_spec.mli,v 1.9 2014/05/06 12:56:21 fclement Exp $ *)

(** {3 History specification} *)

open Scalar_spec;;
open Components_spec;;

module type MAKER =
  functor (Scal : SCALAR) ->
  functor (Comps : COMPONENTS) ->
sig
  module Bb : module type of (Black_box.Make (Scal) (Comps));;
  module St : module type of (State.Make (Scal) (Comps));;
  
  include Uhistory_spec.HISTORY with type state = St.t;;
  
  val h_init : t;;
end
;;
