(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright (c) 2013-2014 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: state_spec.mli,v 1.14 2014/06/11 15:45:35 fclement Exp $ *)

(** {3 State specification} *)

open Scalar_spec;;
open Components_spec;;

module type MAKER =
  functor (Scal : SCALAR) ->
  functor (Comps : COMPONENTS) ->
sig
  module Bb : module type of (Black_box.Make (Scal) (Comps));;
  
  type scalar = Scal.t;;
  type 'a components = 'a Comps.t;;
  type t = Bb.state;;
  
  val same : t -> t -> bool;;
  val equal_coarse_parameters : Bb.partitions -> Bb.selected_cutting -> bool;;
  val print : t Format_printer.printer;;
  
  val init : unit -> t;;
  val final : t -> unit;;
end
;;
