CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                     C
C                              Ref-indic                              C
C                                                                     C
C                        Refinement indicators                        C
C                                                                     C
C               EPI Pomdapi, INRIA Paris - Rocquencourt               C
C                                                                     C
C  Copyright (c) 2013-2014 INRIA.                                     C
C  Institut National de Recherche en Informatique et en Automatique.  C
C  All rights reserved. This file is distributed only by permission.  C
C                                                                     C
C  Hend Ben Ameur <hbenameur@yahoo.ca>                                C
C  Francois Clement <Francois.Clement@inria.fr>                       C
C  Pierre Weis <Pierre.Weis@inria.fr>                                 C
C                                                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C     $Id: rslnag12.f,v 1.6 2014/06/04 15:02:05 fclement Exp $

      subroutine rslnag12(ndS,ndT,S,T,n,job,nbequation)
c     
      implicit integer (z)
      implicit real*8 (t,f,d)
c     
      integer OUTPUT_UNIT
      parameter(OUTPUT_UNIT=18)
c     
      include 'common.fh'
c     
      integer ndS,ndT
      dimension S(ndS), T(ndT)
      real*8 S, T
c     
      integer njunk,job,ipiv,lda,info,m,nbequation,nrhs
      real*8 aa
      dimension aa(nszz,nszz), ipiv(nszz)
      character trans
      common /spnag/ aa, lda, ipiv, info
c     
      njunk = n
      
      if (job.eq.1) go to 5555
      lda = nszz
      do   i   =   1   ,   nszz   ,   1
         do   j   =   1   ,   nszz   ,   1
            aa(i,j) = 0
         enddo
      enddo
      j = 1
      do   i   =   (j-1)*nx+1   ,   j*nx-1   ,   1
         aa(i,i) = (theta*fnu(ndS,S,ndT,T,i,3,3,dt,dx,dy,theta)
     &        -fAinv(i,3,3))*fT(ndT,T,i)
         m = nx*ny+nx+i
         aa(m,i) = (theta*fnu(ndS,S,ndT,T,i,3,1,dt,dx,dy,theta)
     &        -fAinv(i,3,1))*fT(ndT,T,i)
         m = nx*ny+nx+i+1
         aa(m,i) = (theta*fnu(ndS,S,ndT,T,i,3,2,dt,dx,dy,theta)
     &        -fAinv(i,3,2))*fT(ndT,T,i)
         m = i+nx
         aa(m,i) = (theta*fnu(ndS,S,ndT,T,i,3,4,dt,dx,dy,theta)
     &        -fAinv(i,3,4))*fT(ndT,T,i)
      enddo
      i = j*nx
      aa(i,i) = (theta*fnu(ndS,S,ndT,T,i,3,3,dt,dx,dy,theta)
     &     -fAinv(i,3,3))*fT(ndT,T,i)
      m = nx*ny+nx+i
      aa(m,i) = (theta*fnu(ndS,S,ndT,T,i,3,1,dt,dx,dy,theta)
     &     -fAinv(i,3,1))*fT(ndT,T,i)
      m = i+nx
      aa(m,i) = (theta*fnu(ndS,S,ndT,T,i,3,4,dt,dx,dy,theta)
     &     -fAinv(i,3,4))*fT(ndT,T,i)
      i = nx*(ny+1)+(j-1)*nx+1
      aa(i,i) = 1
      do   i   =   nx*(ny+1)+(j-1)*nx+2   ,   nx*(ny+1)+j*nx-1   ,   1
         m = i-nx*ny-nx-1
         zt2 = i-nx*ny-nx-1
         aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt2,2,3,dt,dx,dy,theta)
     &        -fAinv(zt2,2,3))*fT(ndT,T,zt2)
         m = i-nx*ny-1
         zt2 = i-nx*ny-nx-1
         aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt2,2,4,dt,dx,dy,theta)
     &        -fAinv(zt2,2,4))*fT(ndT,T,zt2)
         m = i-nx*ny
         zt2 = i-nx*ny-nx
         aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt2,1,4,dt,dx,dy,theta)
     &        -fAinv(zt2,1,4))*fT(ndT,T,zt2)
         m = i-nx*ny-nx
         zt2 = i-nx*ny-nx
         aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt2,1,3,dt,dx,dy,theta)
     &        -fAinv(zt2,1,3))*fT(ndT,T,zt2)
         m = i-1
         zt2 = i-nx*ny-nx-1
         aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt2,2,1,dt,dx,dy,theta)
     &        -fAinv(zt2,2,1))*fT(ndT,T,zt2)
         zt1 = nx*ny
         zt2 = i-zt1-nx-1
         t3 = fT(ndT,T,zt2)
         zt9 = i-zt1-nx
         t10 = fT(ndT,T,zt9)
         aa(i,i) = t3*theta*fnu(ndS,S,ndT,T,zt2,2,2,dt,dx,dy,theta)
     &        -t3*fAinv(zt2,2,2)
     &        +t10*theta*fnu(ndS,S,ndT,T,zt9,1,1,dt,dx,dy,theta)
     &        -t10*fAinv(zt9,1,1)
         m = i+1
         zt2 = i-nx*ny-nx
         aa(m,i) = -(-theta*fnu(ndS,S,ndT,T,zt2,1,2,dt,dx,dy,theta)
     &        +fAinv(zt2,1,2))*fT(ndT,T,zt2)
      enddo
      i = nx*(ny+1)+j*nx
      m = i-nx*ny-nx-1
      zt2 = i-nx*ny-nx-1
      aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt2,2,3,dt,dx,dy,theta)
     &     -fAinv(zt2,2,3))*fT(ndT,T,zt2)
      m = i-nx*ny-1
      zt2 = i-nx*ny-nx-1
      aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt2,2,4,dt,dx,dy,theta)
     &     -fAinv(zt2,2,4))*fT(ndT,T,zt2)
      m = i-nx*ny
      zt2 = i-nx*ny-nx
      aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt2,1,4,dt,dx,dy,theta)
     &     -fAinv(zt2,1,4))*fT(ndT,T,zt2)
      m = i-nx*ny-nx
      zt2 = i-nx*ny-nx
      aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt2,1,3,dt,dx,dy,theta)
     &     -fAinv(zt2,1,3))*fT(ndT,T,zt2)
      m = i-1
      zt2 = i-nx*ny-nx-1
      aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt2,2,1,dt,dx,dy,theta)
     &     -fAinv(zt2,2,1))*fT(ndT,T,zt2)
      zt1 = nx*ny
      zt2 = i-zt1-nx-1
      t3 = fT(ndT,T,zt2)
      zt9 = i-zt1-nx
      t10 = fT(ndT,T,zt9)
      aa(i,i) = t3*theta*fnu(ndS,S,ndT,T,zt2,2,2,dt,dx,dy,theta)
     &     -t3*fAinv(zt2,2,2)
     &     +t10*theta*fnu(ndS,S,ndT,T,zt9,1,1,dt,dx,dy,theta)
     &     -t10*fAinv(zt9,1,1)
      do   j   =   2   ,   ny   ,   1
         do   i   =   (j-1)*nx+1   ,   j*nx-1   ,   1
            m = i-nx
            zt1 = i-nx
            aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt1,4,3,dt,dx,dy,theta)
     &           -fAinv(zt1,4,3))*fT(ndT,T,zt1)
            zt1 = i-nx
            t2 = fT(ndT,T,zt1)
            t8 = fT(ndT,T,i)
            aa(i,i) = 
     &           t2*theta*fnu(ndS,S,ndT,T,zt1,4,4,dt,dx,dy,theta)
     &           -t2*fAinv(zt1,4,4)
     &           +t8*theta*fnu(ndS,S,ndT,T,i,3,3,dt,dx,dy,theta)
     &           -t8*fAinv(i,3,3)
            m = nx*ny+i
            zt1 = i-nx
            aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt1,4,1,dt,dx,dy,theta)
     &           -fAinv(zt1,4,1))*fT(ndT,T,zt1)
            m = nx*ny+i+1
            zt1 = i-nx
            aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt1,4,2,dt,dx,dy,theta)
     &           -fAinv(zt1,4,2))*fT(ndT,T,zt1)
            m = nx*ny+nx+i
            aa(m,i) = (theta*fnu(ndS,S,ndT,T,i,3,1,dt,dx,dy,theta)
     &           -fAinv(i,3,1))*fT(ndT,T,i)
            m = nx*ny+nx+i+1
            aa(m,i) = (theta*fnu(ndS,S,ndT,T,i,3,2,dt,dx,dy,theta)
     &           -fAinv(i,3,2))*fT(ndT,T,i)
            m = i+nx
            aa(m,i) = (theta*fnu(ndS,S,ndT,T,i,3,4,dt,dx,dy,theta)
     &           -fAinv(i,3,4))*fT(ndT,T,i)
         enddo
         i = j*nx
         m = i-nx
         zt1 = i-nx
         aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt1,4,3,dt,dx,dy,theta)
     &        -fAinv(zt1,4,3))*fT(ndT,T,zt1)
         zt1 = i-nx
         t2 = fT(ndT,T,zt1)
         t8 = fT(ndT,T,i)
         aa(i,i) = t2*theta*fnu(ndS,S,ndT,T,zt1,4,4,dt,dx,dy,theta)
     &        -t2*fAinv(zt1,4,4)
     &        +t8*theta*fnu(ndS,S,ndT,T,i,3,3,dt,dx,dy,theta)
     &        -t8*fAinv(i,3,3)
         m = nx*ny+i
         zt1 = i-nx
         aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt1,4,1,dt,dx,dy,theta)
     &        -fAinv(zt1,4,1))*fT(ndT,T,zt1)
         m = nx*ny+nx+i
         aa(m,i) = (theta*fnu(ndS,S,ndT,T,i,3,1,dt,dx,dy,theta)
     &        -fAinv(i,3,1))*fT(ndT,T,i)
         m = i+nx
         aa(m,i) = (theta*fnu(ndS,S,ndT,T,i,3,4,dt,dx,dy,theta)
     &        -fAinv(i,3,4))*fT(ndT,T,i)
         i = nx*(ny+1)+(j-1)*nx+1
         aa(i,i) = 1
         do   i   =   nx*(ny+1)+(j-1)*nx+2   ,   nx*(ny+1)+j*nx-1
            m = i-nx*ny-nx-1
            zt2 = i-nx*ny-nx-1
            aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt2,2,3,dt,dx,dy,theta)
     &           -fAinv(zt2,2,3))*fT(ndT,T,zt2)
            m = i-nx*ny-1
            zt2 = i-nx*ny-nx-1
            aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt2,2,4,dt,dx,dy,theta)
     &           -fAinv(zt2,2,4))*fT(ndT,T,zt2)
            m = i-nx*ny
            zt2 = i-nx*ny-nx
            aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt2,1,4,dt,dx,dy,theta)
     &           -fAinv(zt2,1,4))*fT(ndT,T,zt2)
            m = i-nx*ny-nx
            zt2 = i-nx*ny-nx
            aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt2,1,3,dt,dx,dy,theta)
     &           -fAinv(zt2,1,3))*fT(ndT,T,zt2)
            m = i-1
            zt2 = i-nx*ny-nx-1
            aa(m,i) = -(
     &           -theta*fnu(ndS,S,ndT,T,zt2,2,1,dt,dx,dy,theta)
     &           +fAinv(zt2,2,1))*fT(ndT,T,zt2)
            zt1 = nx*ny
            zt2 = i-zt1-nx-1
            t3 = fT(ndT,T,zt2)
            zt9 = i-zt1-nx
            t10 = fT(ndT,T,zt9)
            aa(i,i) = 
     &           t3*theta*fnu(ndS,S,ndT,T,zt2,2,2,dt,dx,dy,theta)
     &           -t3*fAinv(zt2,2,2)
     &           +t10*theta*fnu(ndS,S,ndT,T,zt9,1,1,dt,dx,dy,theta)
     &           -t10*fAinv(zt9,1,1)
            m = i+1
            zt2 = i-nx*ny-nx
            aa(m,i) = -(
     &           -theta*fnu(ndS,S,ndT,T,zt2,1,2,dt,dx,dy,theta)
     &           +fAinv(zt2,1,2))*fT(ndT,T,zt2)
         enddo
         i = nx*(ny+1)+j*nx
         m = i-nx*ny-nx-1
         zt2 = i-nx*ny-nx-1
         aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt2,2,3,dt,dx,dy,theta)
     &        -fAinv(zt2,2,3))*fT(ndT,T,zt2)
         m = i-nx*ny-1
         zt2 = i-nx*ny-nx-1
         aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt2,2,4,dt,dx,dy,theta)
     &        -fAinv(zt2,2,4))*fT(ndT,T,zt2)
         m = i-nx*ny
         zt2 = i-nx*ny-nx
         aa(m,i) = -(-theta*fnu(ndS,S,ndT,T,zt2,1,4,dt,dx,dy,theta)
     &        +fAinv(zt2,1,4))*fT(ndT,T,zt2)
         m = i-nx*ny-nx
         zt2 = i-nx*ny-nx
         aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt2,1,3,dt,dx,dy,theta)
     &        -fAinv(zt2,1,3))*fT(ndT,T,zt2)
         m = i-1
         zt2 = i-nx*ny-nx-1
         aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt2,2,1,dt,dx,dy,theta)
     &        -fAinv(zt2,2,1))*fT(ndT,T,zt2)
         zt1 = nx*ny
         zt2 = i-zt1-nx-1
         t3 = fT(ndT,T,zt2)
         zt9 = i-zt1-nx
         t10 = fT(ndT,T,zt9)
         aa(i,i) = t3*theta*fnu(ndS,S,ndT,T,zt2,2,2,dt,dx,dy,theta)
     &        -t3*fAinv(zt2,2,2)
     &        +t10*theta*fnu(ndS,S,ndT,T,zt9,1,1,dt,dx,dy,theta)
     &        -t10*fAinv(zt9,1,1)
      enddo
      j = ny+1
      do   i   =   (j-1)*nx+1   ,   j*nx-1   ,   1
         m = i-nx
         zt1 = i-nx
         aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt1,4,3,dt,dx,dy,theta)
     &        -fAinv(zt1,4,3))*fT(ndT,T,zt1)
         zt1 = i-nx
         aa(i,i) = (theta*fnu(ndS,S,ndT,T,zt1,4,4,dt,dx,dy,theta)
     &        -fAinv(zt1,4,4))*fT(ndT,T,zt1)
         m = nx*ny+i
         zt1 = i-nx
         aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt1,4,1,dt,dx,dy,theta)
     &        -fAinv(zt1,4,1))*fT(ndT,T,zt1)
         m = nx*ny+i+1
         zt1 = i-nx
         aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt1,4,2,dt,dx,dy,theta)
     &        -fAinv(zt1,4,2))*fT(ndT,T,zt1)
      enddo
      i = j*nx
      m = i-nx
      zt1 = i-nx
      aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt1,4,3,dt,dx,dy,theta)
     &     -fAinv(zt1,4,3))*fT(ndT,T,zt1)
      zt1 = i-nx
      aa(i,i) = (theta*fnu(ndS,S,ndT,T,zt1,4,4,dt,dx,dy,theta)
     &     -fAinv(zt1,4,4))*fT(ndT,T,zt1)
      m = nx*ny+i
      zt1 = i-nx
      aa(m,i) = (theta*fnu(ndS,S,ndT,T,zt1,4,1,dt,dx,dy,theta)
     &     -fAinv(zt1,4,1))*fT(ndT,T,zt1)
      call DGETRF(nbequation,nbequation,aa,lda,ipiv,info)
      if (info.ne.0) then
         write(OUTPUT_UNIT,*) 'info = ',info
         stop 'rslnag12: erreur DGETRF'
      endif
 5555 continue
      do   i   =   1   ,   nszz   ,   1
         vvzz(i) = ssmbz(i)
      enddo
      trans = 'N'
      nrhs = 1
      call DGETRS(trans,nbequation,nrhs,aa,lda,ipiv,vvzz,nszz,info)
      return
      end
